#!/bin/sh
/bin/echo "(Re)generating the SSL certificate for anubis..." 
CERTIFICATE='/etc/anubis/cert.pem'
if [ -s $CERTIFICATE ]; then 
    /bin/echo "Moving old certificate ${CERTIFICATE} to ${CERTIFICATE}.old"
    mv -f ${CERTIFICATE} ${CERTIFICATE}.old
fi
PEMTEMP1=`mktemp /tmp/anubis-XXXXXX`
PEMTEMP2=`mktemp /tmp/anubis-XXXXXX`
HOSTNAME=`hostname -s`
FQDN=`hostname -f`
MAILNAME=`cat /etc/mailname 2> /dev/null || hostname -f`
/bin/echo "Do you want to use the defaults (no input required) [Y/n]?"
read ans
case "${ans}" in
    [Nn]*)
    openssl req -newkey rsa:2048 -x509 -days 365 -nodes \
            -keyout $PEMTEMP1 -out $PEMTEMP2
    ;;
    *)
    openssl req -newkey rsa:2048 -x509 -days 365 -nodes \
	    -keyout $PEMTEMP1 -out $PEMTEMP2 > /dev/nul 2>&1 <<EOF
.
.
.
Anubis outgoing mail processor
$HOSTNAME
$FQDN
root@$MAILNAME
EOF
    ;;
esac
umask 166
cat $PEMTEMP1 > $CERTIFICATE
/bin/echo >> $CERTIFICATE
cat $PEMTEMP2 >> $CERTIFICATE
rm -f $PEMTEMP1 $PEMTEMP2

/bin/echo "Certificate has been generated successfully in ${CERTIFICATE}."
exit 0


